﻿class CApplication
{
public:
	CApplication(HINSTANCE aInstance);
	~CApplication();

	void Run();

	void OnDestroy();
	void OnTimer();
	void OnKeyDown(int aKey);
	void OnKeyUp(int aKey);
	void OnChar(int aChar);
	void OnMouseMove(int aX, int aY);
	void OnMouse(bool aRight, bool aUp, int aX, int aY);

	LithDX::CTexture* GetTexture(tlib::TString aTextureName);
	LithDX::CSprite* GetSprite(tlib::TString aSpriteName);

private:
	LithGUI::CGUI *mGUI;
	LithDX::CDX *mDX;
	void Initialise();
	LithGUI::CForm *mMainForm;
	LithDX::CDevice *mDevice;
	tlib::TStringMap<LithDX::CTexture*> mTextures;
	tlib::TStringMap<LithDX::CSprite*> mSprites;
};